/* Defines format of the input raw data ... */

#ifndef RAWDATAinc
#define RAWDATAinc

#define MAX_PATTERN_BITS  16

typedef unsigned long long int TimeStamp64;
typedef unsigned int TimeStamp32;
typedef unsigned int TimeStamp;

#ifdef IS28BITTS

#ifdef BIGENDIAN
typedef struct rawdata {
  unsigned short flags:4;
  unsigned short label:12;
  unsigned short data;
  TimeStamp32 ts;
} RawData;
typedef struct rawinfo {
  unsigned int flags:2;
  unsigned int module:6;
  unsigned int code:4;
  unsigned int info:20;
  TimeStamp32 ts;
} RawInfo;
#else
typedef struct rawdata {
  TimeStamp32 ts;
  unsigned short data;
  unsigned short label:12;
  unsigned short flags:4;
} RawData;
typedef struct rawinfo {
  TimeStamp32 ts;
  unsigned int info:20;
  unsigned int code:4;
  unsigned int module:6;
  unsigned int flags:2;
} RawInfo;
#endif

#else

#ifdef BIGENDIAN
typedef struct rawdata {
  unsigned short label;
  unsigned short data;
  TimeStamp32 ts;
} RawData;
#else
typedef struct rawdata {
  TimeStamp32 ts;
  unsigned short data;
  unsigned short label;
} RawData;
#endif

#endif

#endif
