# Generates sets of arrays  clus0,clus1, etc
#   containing names: name,width,viable, etc.
# Generates sets of arrays  clus0group0,clus1group0, etc
#   for each group defined within a cluster

set MAXCLUSTERS 32
set clusterparamlist ""
set clusterlist ""
set nclusters 0

set cluster_types ""
set cluster_names ""

proc zap-cluster {name} {
    global $name
    set names [array names $name]
    foreach n $names {
	unset [set name]($n)
    }
}

proc zap-clusters {} {
    global MAXCLUSTERS clusterlist cluster_types cluster_names
     set cln 0
    while {$cln < $MAXCLUSTERS} {zap-cluster clus$cln; incr cln}
    set cluster_types ""
    set cluster_names ""
    set clusterlist ""
}

# Need code to generate list of params per cluster [cluster;][group.]param

proc get-param-list {} {
    global nclusters clusterlist paramlist
    
    set nclusters 0
    set paramlist ""
    foreach clus $clusterlist {
	global $clus

	set cname [set [set clus](name)]

	set cluslist ""
	set group 0
	set ngroups [set [set clus](groups)]
	while {$group < $ngroups} {
	    set gname [set clus]group[set group]
	    global $gname
	    set ninst [set [set gname](maxinstances)]
	    
            set grp [set [set gname](name)]

	    set inst 0
	    while {$inst < $ninst} {
		set n inst$inst
		
		set param 0
		set nparams [set [set gname]([set n]nparams)]
		while {$param < $nparams} {
		    if {$ninst > 1} {
			append cluslist  "$grp.[first [set [set gname]([set n]param[set param])]] "
		    } {
			append cluslist  "[first [set [set gname]([set n]param[set param])]] "
		    }
		    incr param
		}
		break
	    }

	    incr group
	}

	append cluslist " =xpos =ypos"

	set [set clus](histparamlist) $cluslist
        incr nclusters
	append paramlist $cluslist
    }
}

proc get-param-list-all {} {
    global clusterparamlist
    return $clusterparamlist
}

proc get-detector-list {this} {
    global nclusters
    set nn 0
    set list ""
    while {$nn < $nclusters} {
	set clus clus$nn
        global $clus
	set cname [set [set clus](type)]
	if {$cname == $this} {incr nn;continue}
	# Output all detector entries ...	
	append list " $cname"
	incr nn
    } 
    return $list
}

proc get-node-list-all {} {
    return [get-node-list ""]
}

proc get-node-list {this} {
    global MAXNODES nclusters
    set nn 1
    set nodelist ""
    while {$nn < $MAXNODES} {
	set node node$nn
	if {$node == $this} {incr nn;continue}
        global $node
	# Output all nodes entries ...	
	set names [array names $node]
	if {$names == ""} {incr nn;continue}
	incr nn
	append nodelist " $node"
    } 
    return $nodelist
}

proc get-down-node-list {this} {
    global $this
    set node [set [set this](down)]
    set nodelist ""
    while {$node != "nodebase"} {
	global $node
	append nodelist " $node"
	set node [set [set node](down)]
    } 
    return $nodelist
}

proc get-nodename-list {} {
    set list [get-node-list ""]
    set newlist ""
    foreach l $list {
	global $l
	append newlist " [set [set l](name)]"
    }
    return $newlist
}

proc get-histparam-list {node} {
    global $node MAXNODES nclusters
    get-param-list

    set type [set [set node](detectors)]
    for {set c 0} {$c < $nclusters} {incr c} {
	set clus clus[set c]
	global $clus
	if {[set [set clus](type)] == $type} {
	    return [set [set clus](histparamlist)]
	}
    }
    return ""
}

proc click-clusterload {f} {
    global clusterparamlist clusterlist
    global templates cluster_names cluster_types
    clear-footer

    set buf [read-file $f]

    zap-clusters

    set cluster_names ""
    set cluster_types ""
    set clusterlist ""
    set clusterparamlist ""
    set clusnum -1
    foreach l $buf {
	if {$buf == ""} {continue}
	switch [first $l] {
	    cluster {
		incr clusnum
		set currentcluster clus$clusnum
		append clusterlist "clus$clusnum "


		set type [second $l]
		set name [third $l]
		set found 0
		foreach t $templates {
		    if {[first $t] == $name} {
			if {[second $t] == $type} {
			set found 1
			}
		    }
		}
		if {! $found} {
		    set-footer "Cluster type [second $l] not found! Adjust input file"
		    return
		}
		lappend cluster_types $type
		lappend cluster_names $name

		global clus$clusnum
		set nn [array names $currentcluster]
		foreach n $nn { unset [set currentcluster]($n) }

# Set-from-template here ...
                set clus [cluster-set-variables $name]

		set [set currentcluster](type) $type
		set [set currentcluster](name) $name
#
		set [set currentcluster](init) ""
		set [set currentcluster](accept) ""
#		set [set currentcluster](pileup) "Veto"
		set [set currentcluster](store) ""
		set [set currentcluster](actions) 0

#
		global clus[set clusnum]group0
		set [set currentcluster]group0(maxinstances) 1
		set group -1
		set inst 0
		set param 0
		set action 0
	    }
	    action {
		set n [string length [first $l]]
		global [set currentcluster]action
		set [set currentcluster]action([set action]) [string range $l [expr $n +1] end]
		incr action
		set [set currentcluster](actions) $action
	    }
	    maxinstances {
		incr group
		set gname [set currentcluster]group[set group]
		global $gname
		set [set gname](maxinstances) [second $l]
		set [set gname](name) [third $l]
		set [set currentcluster](groups) [expr $group +1]

#		set [set gname](histlen1d) 16384
#		set [set gname](histlen2d) 1024

		set param 0
	    }
	    histparams {
#		puts "click-clusterload [set gname] ... $l"
#		set [set gname](histlen1d) [second $l]
		set [set gname](histscale1d) [third $l]
#		set [set gname](histlen2d) [fourth $l]
		set [set gname](histscale2d) [fifth $l]
	    }
	    instance {
		set inst [second $l]
		if {$inst >= [set [set gname](maxinstances)]} {
		    set [set gname](maxinstances) [expr $inst +1]
		}
		set param 0
	    }
	    pattern {
		set par $l
		set [set gname](inst[set inst]param[set param]) $par
		incr param
		set [set gname](inst[set inst]nparams) $param
	    }
	    param {
		set n [string length [first $l]]
		set par [string range $l [expr $n +1] end]

#Test param name against entry set from template ...

		if {[string first "dts=" $par] == -1} {
		    append par " dts=0"
		}

		# Set list of vxi names vs. param names ...
		
		if {[set [set currentcluster](maxgroups)] > 1} {
		    if {[set [set gname](maxinstances)] > 1} {
			lappend clusterparamlist "[set [set currentcluster](name)]_[set [set gname](name)][set inst].[second $l] \"[third $l]\" [set gname](inst[set inst]param[set param])"
		    } {
			if {[set [set gname](name)] == ""} {set gn ""} {set gn "_[set [set gname](name)]"}
			lappend clusterparamlist "[set [set currentcluster](name)][set gn].[second $l] \"[third $l]\" [set gname](inst[set inst]param[set param])"
		    }
		} {
		    if {[set [set gname](maxinstances)] > 1} {
			lappend clusterparamlist "[set [set currentcluster](name)]_[set inst].[second $l] \"[third $l]\" [set gname](inst[set inst]param[set param])"
		    } {
			lappend clusterparamlist "[set [set currentcluster](name)].[second $l] \"[third $l]\" [set gname](inst[set inst]param[set param])"
		    }
		}

		set [set gname](inst[set inst]param[set param]) $par
		incr param
		set [set gname](inst[set inst]nparams) $param
	    }
	    xymatch {
	    }
	    bgocluster {
#		puts "bgocluster $name [first $l] [second $l] [set [set currentcluster]([first $l])]"
	    }
	    viable {
#puts "!!![set currentcluster](viable)"
		if {[llength $l] < 4} {
		    set [set currentcluster](viable) "[second $l] fold 1"
		} {
		    set [set currentcluster](viable) "[second $l] [third $l] [fourth $l]"
		}
	    }
	    fold {
	    }
	    default {
		set [set currentcluster]([first $l]) [second $l]
	    }
	}
    }
    get-param-list
}

proc click-clustersave {f} {
   global clusterlist
    clear-footer

    set buf ""
    foreach clus $clusterlist {
        global $clus
	# Output all clusters entries ...	
	set names [array names $clus]
	if {$names == ""} {continue}
	puts "click-clustersave: $clus [set [set clus](type)]"
	lappend buf ""
	lappend buf "cluster [set [set clus](type)] [set [set clus](name)]"
	foreach name $names {
	    if {$name == "maxgroups"} {continue}
	    if {$name == "name"} {continue}
	    if {$name == "type"} {continue}
	    if {$name == "groups"} {continue}
	    if {$name == "histparamlist"} {continue}
	    if {[string range $name 0 5] == "action"} {continue}
	    if {[set [set clus]($name)] != ""} {
		lappend buf "$name [set [set clus]($name)]"
	    }
	}

	set group 0
	set ngroups [set [set clus](groups)]

	lappend buf "maxgroups $ngroups"

	while {$group < $ngroups} {
	    set gname [set clus]group[set group]
	    global $gname
	    
	    set ninst [set [set gname](maxinstances)]
	    puts "maxinstances $ninst [set [set gname](name)]"
	    lappend buf "maxinstances $ninst [set [set gname](name)]"
	    lappend buf "histparams [set [set gname](histlen1d)] [set [set gname](histscale1d)] [set [set gname](histlen2d)] [set [set gname](histscale2d)]"

	    set inst 0
	    while {$inst < $ninst} {
		lappend buf "instance $inst"
		set n inst$inst
		
		set param 0
		set nparams [set [set gname]([set n]nparams)]
		while {$param < $nparams} {
		    set par [set [set gname]([set n]param[set param])]

		    if {[first $par] == "pattern"} {
			lappend buf $par
		    } {
			lappend buf "param $par"
		    }
		    incr param
		}
		incr inst
	    }

	    incr group
	}

	global [set clus]action
	set act 0
	set nacts [set [set clus](actions)]
	while {$act < $nacts} {
	    set n [string range $name 6 end]
	    lappend buf "action [set [set clus]action($act)]"
	    incr act
	}
    }
    
    write-file $f $buf
}






